Description: Use shared modp_b64
 These changed are necessary to use the shared library
 modpbase64 from Debian.
Author: Tobias Hansen <thansen@debian.org>

--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -63,6 +63,7 @@
 option(USE_SHARED_TINYXML "Use your installed copy of tinyxml" off)
 option(USE_SHARED_PIXMAN  "Use your installed copy of pixman" off)
 option(USE_SHARED_FREETYPE "Use shared FreeType library" off)
+option(USE_SHARED_MODP_B64 "Use shared modp_b64 library" off)
 option(USE_SHARED_ALLEGRO4 "Use shared Allegro 4 library (without resize support)" off)
 option(ENABLE_MEMLEAK     "Enable memory-leaks detector (only for developers)" off)
 option(ENABLE_UPDATER     "Enable automatic check for updates" on)
@@ -282,6 +283,14 @@
 endif()
 include_directories(${CURL_INCLUDE_DIRS})
 
+if(USE_SHARED_MODP_B64)
+  find_library(LIBMODP_LIBRARY NAMES modpbase64)
+  find_path(LIBMODP_INCLUDE_DIR NAMES modp_b64.h)
+else()
+  set(LIBMODP_LIBRARY modp_b64)
+endif()
+include_directories(${LIBMODP_INCLUDE_DIR})
+
 # simpleini
 include_directories(${SIMPLEINI_DIR})
 
--- a/third_party/CMakeLists.txt
+++ b/third_party/CMakeLists.txt
@@ -89,5 +89,8 @@
   endif()
 endif()
 
+if(NOT USE_SHARED_MODP_B64)
+  add_subdirectory(modp_b64)
+endif()
+
 add_subdirectory(simpleini)
-add_subdirectory(modp_b64)
--- a/src/base/base64.cpp
+++ b/src/base/base64.cpp
@@ -11,6 +11,7 @@
 #include "base/base64.h"
 
 #include "modp_b64.h"
+#define MODP_B64_ERROR ((size_t)-1)
 
 namespace base {
 
--- a/src/base/CMakeLists.txt
+++ b/src/base/CMakeLists.txt
@@ -25,7 +25,9 @@
     CACHE STRING "modp_b64 directory")
 
 include_directories(${BASE_INCLUDE_DIR})
-include_directories(${MODP_B64_DIR})
+if(NOT USE_SHARED_MODP_B64)
+  include_directories(${MODP_B64_DIR})
+endif()
 
 set(BASE_SOURCES
   base64.cpp
@@ -71,7 +73,7 @@
 
 # TODO remove dependency with observable library
 add_library(base-lib ${BASE_SOURCES})
-target_link_libraries(base-lib obs modp_b64)
+target_link_libraries(base-lib obs ${LIBMODP_LIBRARY})
 
 if(WIN32)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
